#!/bin/sh

# ----------------------------------------------------------------------------------------------------------------
#	2008-01-08		v0.0.1
#	2008-01-14		v0.0.2
#	2008-01-15		v0.0.3
#	2008-03-05		v0.0.4
#						Add "(P)PTF"
#	2008-04-29		v0.0.5
#						modify PTF , disable WDT before kill main_daemon
#	2008-05-19		v0.0.6
#					Add (D) dis_wdt
#	2008-05-28		v0.0.7
#					Test /sbin/sulogin instead of /bin/sh
#	2008-05-28		v0.0.8
#					remove '(S)shell' , Add '(L)Login' , Add'(S)sulogin'
#	2008-06-02		v0.0.9
#					Test Version . Add'R' (Hide) , Entry shell directly
#	2008-06-06		v0.1.0
#					DIsable 'R'
#	2008-07-28		v0.1.1
#					Disable 'P'
#	2008-12-17		V0.1.2
#					Disable 'L' / 'S'  . modify login string "asd"
#					Hide 'D'
#	2009-02-09		V0.1.3  Triocom edition
#					welcom message	
#	2009-02-16		v0.1.4	Triocom edition update
#	2009-02-17		v0.1.5	DG edition  support read "-s"
#	2009-04-22		v0.1.6	no support read "-s"
#	2009-08-20		v0.1.7	support config welcome message ; support config user and password
#	
#------------------------------------------------------------------------------------------------------------------


#
# Display what is the Shell
#
VER=0.1.7

ENTER=`echo -e "\n"`

chkip () {
	echo $1 |awk -F"." '
	{
        	if ( 	($1<=256 && $1>=0) &&
                      	($2<=256 && $2>=0) &&
                	($3<=256 && $3>=0) &&
                	($4<=256 && $4>=0) &&
                	(NF==4) &&
                	($1~/^[0-9]+$/) &&
                	($2~/^[0-9]+$/) &&
                	($3~/^[0-9]+$/) &&
                	($4~/^[0-9]+$/))
        	{
                	print "0"
        	}
        	else
        	{
                	print "1"
        	}
	}'
}

#welcome=`grep -s "WELCOME_MSG" /home/config/cli.conf | cut -f2 -d":"`
#change by camel 20100910
welcome=`grep -s "WELCOME_MSG" /home/config/cli.conf | cut -f2 -d":"`
echo "*****************************************"
echo -e "*\t\t\t\t\t*"
echo    "* "$welcome " *"                       
echo -e "*\t\t\t\t\t*"
echo "*****************************************"
echo ""

while true; do
	echo -n "User : "
	read USER
	echo ""
	cli_file=`ls -1 /home/config/cli.conf | cut -f4 -d"/"`
	if [ $cli_file = "cli.conf" ]; then
		cli_user1=`grep -s "USER1" /home/config/cli.conf | cut -f2 -d":"`
		cli_user2=`grep -s "USER2" /home/config/cli.conf | cut -f2 -d":"`
		cli_passwd1=`grep -s "USER1" /home/config/cli.conf | cut -f3 -d":"`
		cli_passwd2=`grep -s "USER2" /home/config/cli.conf | cut -f3 -d":"`
		case $USER in 
			$cli_user1)
				echo -n "Password : "
				read PASSWD
				echo ""
				case $PASSWD in
					$cli_passwd1)
						break
						;;
					*)
						echo "Wrong Password"
						;;
				esac
				;;
			$cli_user2)
				echo -n "Password : "
				read PASSWD
				echo ""
				case $PASSWD in
					$cli_passwd2)
						break
						;;
					*)
						echo "Wrong Password"
						;;
				esac
				;;
			*)
				echo -n "No such user : " $USER
				echo ""
				;;
		esac
	else
		echo "Access Refused"
	fi
done


echo ""
echo "Command Line Interface "
echo "Version $VER "
echo ""

while true; do
	#echo "(1)agent_query		:	Query IDU/ODU"
	#echo "(2)agent_setup		:	Setup IDU/ODU"
	echo "(3)query_IP		:	Query IP Address"
	echo "(4)query_MAC		:	Query HwAddress"
	echo "(5)query_MASK		:	Query NetMask"
	echo "(6)set_IP		:	Setup IP Address"
	echo "(7)set_MAC		:	Setup HwAddress"
	echo "(8)set_MASK		: 	Setup NetMask"
	#echo "(L)login		:	login"
	#echo "(S)sulogin		:	sulogin"
	#echo "(D)disWDT		:	disable_WDT"
	echo "(Q)Quit			:	Quit"

	echo  -n "Select and press ENTER : "
	read KEY
	echo ""

	case $KEY in
		3)
			echo "----------------------------------"
			echo "  Query IP Address"
			SYS_IP=`/home/PDH/query_sys.sh 0x010F | cut -f2 -d" "`
			echo -n "  IDU IP Address : " $SYS_IP
			echo ""
			echo "----------------------------------"
			;;
		4)
			echo "----------------------------------"
			echo "  Query MAC Address"
			SYS_MAC=`/home/PDH/query_sys.sh 0x010E | cut -f2 -d" "`
			echo -n "  IDU MAC Address : " $SYS_MAC
			echo ""
			echo "----------------------------------"
			;;
		5)
			echo "----------------------------------"
			echo "  Query Net Mask"
			SYS_MASK=`/home/PDH/query_sys.sh 0x0110 | cut -f2 -d" "`
			echo -n "  IDU Mask Address : " $SYS_MASK
			echo ""
			echo "----------------------------------"
			;;
		6)
			echo "----------------------------------"
			echo "Setup IP Address"
			echo  -n "Enter IP address and press ENTER : "
			read USER_IP
			echo -n "Input IP Address : " $USER_IP
			echo ""
			CHK=`chkip $USER_IP`
			if [ $CHK = '0' ]; then
				/home/PDH/setup_sys.sh 0x010F $USER_IP
			elif [ $CHK = '1' ]; then
				echo "Please input legal IP address"
			fi 
			echo "----------------------------------"
			;;	
		7)
			echo "----------------------------------"
			echo "Setup HwAddress"
			echo -n "Enter HwAddress and press ENTER : "
			read USER_MAC
			echo "Input MAC : $USER_MAC"
			/home/PDH/setup_sys.sh 0x010E $USER_MAC
			echo "----------------------------------"
			;;
		9)
			echo "----------------------------------"
			echo "Setup Net Mask"
			echo  -n "Enter Net Mask and press ENTER : "
			read USER_MASK
			echo -n "Input Net Mask : " $USER_MASK
			echo ""
			CHK=`chkip $USER_MASK`
			if [ $CHK = '0' ]; then
				/home/PDH/setup_sys.sh 0x0110 $USER_MASK
			elif [ $CHK = '1' ]; then
				echo "Please input legal IP address"
			fi 
			echo "----------------------------------"
			;;
		asd)
			/sbin/sulogin
			;;
		D)
			/home/PDH/dis_wdt.sh > /tmp/NULL
			;;
		Q)
			exit
			;;
		*)
			echo ""
			;;
	esac
done
