#!/bin/sh

# ------------------------------------------------------------------------------------------------------
#	2007-11-07		v0.0.2
#						Save IDU Protect Mode
#						Save IDU E1Num_Local
#						Save IDU E1Num_W
#						Save IDU E1Num_E
#						Save IDU E1EthCfg_W
#						Save IDU E1EthCfg_E
#						Save IDU Xc						
#						Save IDU E1Malloc
#	2007-11-09		v0.0.3
#						Add IDU AOV_W
#						Add IDU AOV_E
#						Add IDU SwitchMode
#						Add IDU Force TX
#						Add IDU Force RX
#						Add IDU Switch TX
#						Add IDU Switch RX	
#	2007-12-04		v0.0.4
#						this SAVE.sh use to save "setup_idu.sh"
#	2007-12-24		v0.0.5
#						this SAVE.sh use to save "setup_odu.sh"
#	2008-01-20  	v0.0.6
#						fix path bug in chPara
#	2008-01-23		v0.0.7
#						fix SWITCHMODE bug in SwitchMode
#	2008-01-30		v0.0.8
#						Add IDU BranchSel
#						Add IDU TxMode
#	2008-01-31		v0.0.9
#						change TXMODE_IDU to TXMOD_IDU
#	2008-04-29		v0.1.0
#						Add IDU ATPC 
#	2008-05-23		v0.1.1
#						modift path of PDH_IDU.conf 
#	2009-01-07		v0.1.2
#						add dry contact ( dry.conf )
#						add etherport (eherport.conf)
#-----------------------------------------------------------------------------------------------------------

#
# Display what is the shell
#
VER=0.1.2
echo " Save Shell Versin $VER"

#
# Define Obj : PDH_IDU.conf == save.sh == setup_idu.sh == setup_odu.sh
#	
OBJ_IDU_MODE=0x0402
OBJ_IDU_E1_NUM_L=0x0002									# undefined for User
OBJ_IDU_E1_NUM_W=0x0419
OBJ_IDU_E1_NUM_E=0x041C
OBJ_IDU_ETH_CFG_W=0x041A
OBJ_IDU_ETH_CFG_E=0x041D
OBJ_IDU_XC=0x041F
OBJ_IDU_E1_MALLOC_W=0x0008								# undefined for User
OBJ_IDU_E1_MALLOC_E=0x0009								# undefined for User
OBJ_IDU_E1_MALLOC_L=0x000A								# undefined for User
OBJ_IDU_AOV_W=0x0409
OBJ_IDU_AOV_E=0x040A
OBJ_IDU_BRANCHSEL=0x040D
OBJ_IDU_TXMOD=0x040E
OBJ_IDU_SWITCHMODE=0x040F
OBJ_IDU_FORCE_TX=0x0410
OBJ_IDU_FORCE_RX=0x0411
OBJ_IDU_SWITCH_TX=0x0412
OBJ_IDU_SWITCH_RX=0x0413
OBJ_IDU_ATPC_WEST=0x0420
OBJ_IDU_ATPC_EAST=0x0429
OBJ_IDU_ATPC_MAX_RXLEVEL_WEST=0x042A
OBJ_IDU_ATPC_MIN_RXLEVEL_WEST=0x042B
OBJ_IDU_ATPC_MAX_RXLEVEL_EAST=0x042C
OBJ_IDU_ATPC_MIN_RXLEVEL_EAST=0x042D
# ------------------------- ODU -----------------------------
OBJ_ODU_CHANNEL_WEST=0x0603
OBJ_ODU_TXPOWER_WEST=0x0604
OBJ_ODU_RXALARMLEVEL_WEST=0x061F
OBJ_ODU_TXSWITCH_WEST=0x0620
OBJ_ODU_CHANNEL_EAST=0x0503
OBJ_ODU_TXPOWER_EAST=0x0504
OBJ_ODU_RXALARMLEVEL_EAST=0x051F
OBJ_ODU_TXSWITCH_EAST=0x0520
# ------------------------Dry Contact ---------------------
OBJ_DRY1_PHASE_REVERSE=0x0302
OBJ_DRY1_OUTPUT=0x0303
OBJ_DRY2_PAHSE_REVERSE=0x0305
OBJ_DRY2_OUTPUT=0x0306
# ---------------------- Erhernet Port ---------------------
OBJ_NMS_PORT0_SPEED=0x0701
OBJ_NMS_PORT0_DUPLEX=0x0702
OBJ_NMS_PORT0_AN=0x0703
OBJ_NMS_PORT0_MFL=0x0704
OBJ_NMS_PORT0_FC=0x0705
OBJ_NMS_PORT1_SPEED=0x0801
OBJ_NMS_PORT1_DUPLEX=0x0802
OBJ_NMS_PORT1_AN=0x0803
OBJ_NMS_PORT1_MFL=0x0804
OBJ_NMS_PORT1_FC=0x0805
OBJ_IP_PORT0_SPEED=0x0901
OBJ_IP_PORT0_DUPLEX=0x0902
OBJ_IP_PORT0_AN=0x0903
OBJ_IP_PORT0_MFL=0x0904
OBJ_IP_PORT0_FC=0x0905
OBJ_IP_PORT1_SPEED=0x0B01
OBJ_IP_PORT1_DUPLEX=0x0B02
OBJ_IP_PORT1_AN=0x0B03
OBJ_IP_PORT1_MFL=0x0B04
OBJ_IP_PORT1_FC=0x0B05

chPara(){
#	echo $@;
#	echo $1
#	echo $2
	local findresult="`grep "$1=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`";
#	echo "${findresult}";
	local old=${findresult};
#	echo $old;
#	sed -i -e "s|$1=$old|$1=$2|g" /home/PDH/PDH_IDU.conf
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/PDH_IDU.conf
}

chDry(){
#	echo "AA"
	local findresult="`grep "$1=" /home/config/dry.conf | cut -f2 -d"="`";
	local old=${findresult};
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/dry.conf
}

chPort(){
	local findresult="`grep "$1=" /home/config/etherport.conf | cut -f2 -d"="`";
	local old=${findresult};
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/etherport.conf
}

#
# IDU Mode
#
if [ $1 = $OBJ_IDU_MODE ]; then
	chPara MODE_IDU $2
fi

#
# IDU E1 Num Local
#
if [ $1 = $OBJ_IDU_E1_NUM_L ]; then
	chPara E1_NUM_L_IDU $2
fi

#
# IDU E1 Num West
#
if [ $1 = $OBJ_IDU_E1_NUM_W ]; then
	chPara E1_NUM_W_IDU $2
fi

#
# IDU E1 Num East
#
if [ $1 = $OBJ_IDU_E1_NUM_E ]; then
	chPara E1_NUM_E_IDU $2
fi

#
# IDU Eth Cfg West
#
if [ $1 = $OBJ_IDU_ETH_CFG_W ]; then
	chPara ETH_CFG_W_IDU $2
fi

#
# IDU Eth Cfg East
#
if [ $1 = $OBJ_IDU_ETH_CFG_E ]; then
	chPara ETH_CFG_E_IDU $2
fi

#
# IDU Xc
#
if [ $1 = $OBJ_IDU_XC ]; then
	chPara XC_IDU $2
fi

#
# IDU E1 Malloc West
#
if [ $1 = $OBJ_IDU_E1_MALLOC_W ]; then
	chPara E1_MALLOC_W_IDU $2
fi

#
# IDU E1 Malloc East
#
if [ $1 = $OBJ_IDU_E1_MALLOC_E ]; then
	chPara E1_MALLOC_E_IDU $2
fi

#
# IDU E1 Malloc Local
#
if [ $1 = $OBJ_IDU_E1_MALLOC_L ]; then
	chPara E1_MALLOC_L_IDU $2
fi

#
# IDU AOV West
#
if [ $1 = $OBJ_IDU_AOV_W ]; then
	chPara AOV_W_IDU $2
fi

#
# IDU AOV East
#
if [ $1 = $OBJ_IDU_AOV_E ]; then
	chPara AOV_E_IDU $2
fi

#
# IDU BranchSel
#
if [ $1 = $OBJ_IDU_BRANCHSEL ]; then
	chPara BRANCHSEL_IDU $2
fi

#
# IDU TxMode
#
if [ $1 = $OBJ_IDU_TXMOD ]; then
	chPara TXMOD_IDU $2
fi

#
# SwitchMode
#
if [ $1 = $OBJ_IDU_SWITCHMODE ]; then
	chPara SWITCH_IDU $2
fi

#
# IDU Force TX
#
if [ $1 = $OBJ_IDU_FORCE_TX ]; then
	chPara FORCE_TX_IDU $2
fi

#
# IDU Force Rx
#
if [ $1 = $OBJ_IDU_FORCE_RX ]; then
	chPara FORCE_RX_IDU $2
fi

#
# IDU Switch Tx
#
if [ $1 = $OBJ_IDU_SWITCH_TX ]; then
	chPara SWITCH_TX_IDU $2
fi

#
# IDU Switch Rx
#
if [ $1 = $OBJ_IDU_SWITCH_RX ]; then
	chPara SWITCH_RX_IDU $2
fi

#
# IDU ATPC West
#
if [ $1 = $OBJ_IDU_ATPC_WEST ]; then
	chPara ATPC_WEST_IDU $2
fi

#
# IDU ATPC MAX RxLevel West
#
if [ $1 = $OBJ_IDU_ATPC_MAX_RXLEVEL_WEST ]; then
	chPara ATPC_MAX_RXLEVEL_WEST_IDU $2
fi

#
# IDU ATPC MIN RxLevel West
#
if [ $1 = $OBJ_IDU_ATPC_MIN_RXLEVEL_WEST ]; then
	chPara ATPC_MIN_RXLEVEL_WEST_IDU $2
fi

#
# IDU ATPC East
#
if [ $1 = $OBJ_IDU_ATPC_EAST ]; then
	chPara ATPC_EAST_IDU $2
fi

#
# IDu ATPC MAX RxLevel East
#
if [ $1 = $OBJ_IDU_ATPC_MAX_RXLEVEL_EAST ]; then
	chPara ATPC_MAX_RXLEVEL_EAST_IDU $2
fi

#
# IDU ATPC MIN RxLevel East
#
if [ $1 = $OBJ_IDU_ATPC_MIN_RXLEVEL_EAST ]; then
	chPara ATPC_MIN_RXLEVEL_EAST_IDU $2
fi

#
# ODU Channel West
#
if [ $1 = $OBJ_ODU_CHANNEL_WEST ]; then
	chPara CHANNEL_WEST_ODU $2
fi

#
# ODU TxPower West
#
if [ $1 = $OBJ_ODU_TXPOWER_WEST ]; then
	chPara TXPOWER_WEST_ODU $2
fi

#
# ODU RxAlarmLevel West
#
if [ $1 = $OBJ_ODU_RXALARMLEVEL_WEST ]; then
	chPara RXALARMLEVEL_WEST_ODU $2
fi

#
# ODU TxSwitch West
#
if [ $1 = $OBJ_ODU_TXSWITCH_WEST ]; then
	chPara TXSWITCH_WEST_ODU $2
fi

#
# ODU Channel East
#
if [ $1 = $OBJ_ODU_CHANNEL_EAST ]; then
	chPara CHANNEL_EAST_ODU $2
fi

#
# ODU TxPower East
#
if [ $1 = $OBJ_ODU_TXPOWER_EAST ]; then
	chPara TXPOWER_EAST_ODU $2
fi

#
# ODU RxAlarmLevel East
#
if [ $1 = $OBJ_ODU_RXALARMLEVEL_EAST ]; then
	chPara RXALARMLEVEL_EAST_ODU $2
fi

#
# ODU TxSwitch East
#
if [ $1 = $OBJ_ODU_TXSWITCH_EAST ]; then
	chPara TXSWITCH_EAST_ODU $2
fi

# Dry Contact 1 Phase Reverse
if [ $1 = $OBJ_DRY1_PHASE_REVERSE ]; then
	chDry DRY_1_PHASE_REVERSE $2
fi

# Dry Contact 1 Output
if [ $1 = $OBJ_DRY1_OUTPUT ]; then
	chDry DRY_1_OUTPUT $2
fi

# Dry Contact 2 Phase Reverse
if [ $1 = $OBJ_DRY2_PAHSE_REVERSE ]; then
	chDry DRY_2_PHASE_REVERSE $2
fi

# Dry Contact 2 Output
if [ $1 = $OBJ_DRY2_OUTPUT ]; then
	chDry DRY_2_OUTPUT $2
fi

# NMS Port0 Speed
if [ $1 = $OBJ_NMS_PORT0_SPEED ]; then
	chPort NMS_PORT0_SPEED $2
fi
# NMS Port0 Duplex
if [ $1 = $OBJ_NMS_PORT0_DUPLEX ]; then
	chPort NMS_PORT0_DUPLEX $2
fi
# NMS Port0 Auto Negotiation
if [ $1 = $OBJ_NMS_PORT0_AN ]; then
	chPort NMS_PORT0_AN $2
fi
# NMS Port0 Max Frame Length
if [ $1 = $OBJ_NMS_PORT0_MFL ]; then
	chPort NMS_PORT0_MFL $2
fi
# NMS Port0 Flow Control
if [ $1 = $OBJ_NMS_PORT0_FC ]; then
	chPort NMS_PORT0_FC $2
fi

# NMS Port1 Speed
if [ $1 = $OBJ_NMS_PORT1_SPEED ]; then
	chPort NMS_PORT1_SPEED $2
fi
# NMS Port1 Duplex
if [ $1 = $OBJ_NMS_PORT1_DUPLEX ]; then
	chPort NMS_PORT1_DUPLEX $2
fi
# NMS Port1 Auto Negotiation
if [ $1 = $OBJ_NMS_PORT1_AN ]; then
	chPort NMS_PORT1_AN $2
fi
# NMS Port1 Max Frame Length
if [ $1 = $OBJ_NMS_PORT1_MFL ]; then
	chPort NMS_PORT1_MFL $2
fi
# NMS Port1 Flow Control
if [ $1 = $OBJ_NMS_PORT1_FC ]; then
	chPort NMS_PORT1_FC $2
fi

# IP Port0 Speed
if [ $1 = $OBJ_IP_PORT0_SPEED ]; then
	chPort IP_PORT0_SPEED $2
fi
# IP Port0 Duplex
if [ $1 = $OBJ_IP_PORT0_DUPLEX ]; then
	chPort IP_PORT0_DUPLEX $2
fi
# IP Port0 Auto Negotiation
if [ $1 = $OBJ_IP_PORT0_AN ]; then
	chPort IP_PORT0_AN $2
fi
# IP Port0 Max Frame Length
if [ $1 = $OBJ_IP_PORT0_MFL ]; then
	chPort IP_PORT0_MFL $2
fi
# IP Port0 Flow Control
if [ $1 = $OBJ_IP_PORT0_FC ]; then
	chPort IP_PORT0_FC $2
fi

# IP Port1 Speed
if [ $1 = $OBJ_IP_PORT1_SPEED ]; then
	chPort IP_PORT1_SPEED $2
fi
# IP Port1 Duplex
if [ $1 = $OBJ_IP_PORT1_DUPLEX ]; then
	chPort IP_PORT1_DUPLEX $2
fi
# IP Port1 Auto Negotiation
if [ $1 = $OBJ_IP_PORT1_AN ]; then
	chPort IP_PORT1_AN $2
fi
# IP Port1 Max Frame Length
if [ $1 = $OBJ_IP_PORT1_MFL ]; then
	chPort IP_PORT1_MFL $2
fi
# IP Port1 Flow Control
if [ $1 = $OBJ_IP_PORT1_FC ]; then
	chPort IP_PORT1_FC $2
fi





