#!/bin/sh

# ---------------------------------------------------------------------------------------------------------------------------------------------------------
#	2007-11-01		v0.0.1
#						Location
#						IP
#						MASK
#						Gate				no support
#						TrapHost1
#						TrapHost2
#						TrapHost3
#	2007-11-28		v0.0.2
#						RTC
#	2007-12-25		v0.0.3
#						PN/SN
#	2007-12-29		v0.0.4
#						MAC
#						save netmask to /etc/network/interfaces
#						save gateway to /etc/network/interfaces
#	2008-01-28		v0.0.5
#						./setup_idu.sh 0x0A01 IP when set IP 
#	2008-02-27		v0.0.6
#						restart CPU
#	2008-04-14		v0.0.7
#						reboot.sh instead of /sbin/reboot
#	2008-04-14		v0.0.8
#						HWADDR in MAC.conf instead of PDH_IDU.conf , Add chMAC func.
#	2008-05-15		v0.0.9
#						Add log
#	2008-05-23		v0.1.0
#						modify path of PDH_IDU.conf
#						modify paht of MAC.conf
#	2008-07-14		v0.1.1
#						./setup_idu.sh 0x0A0C SiteName when set Location
#	2009-02-11		v0.1.2
#						add setup snmp community
#	2009-04-29		v0.1.3		modify path of snmpd.conf
#						setup snmp : mail , web , trapport
#	2009-08-20		v0.1.4		setup web user name
#						setup web password
#						setup mac_man
#						update MAC.conf
#						setup cli welcome message
#						setup cli user name
#						setup cli password
#						setup product name to product.conf
#						setup product description to product.conf
#						update SDH_IDU.conf with product.conf
# 	2010-01-20 		v0.1.5 		setup address ( short.ssn ) , generate short.ssn
# 	2010-01-22 		v0.1.6 		update license
# 	2010-03-09 		v0.1.7 		modify update license : only output ERRCODE without '\n'
# 	2010-03-10 		v0.1.8 		modify update license : restrict num of args.
# 						add delete license file ( at /home/cofig/ )
# 	2010-05-26 		v0.1.9 		modify update license , output error code with new line.
#	2010-09-10		v0.1.10		surport oem export
#-------------------------------------------------------------------------------------------------------------------------------------------------------------


#
# Display what is the Shell
#
VER=0.1.9
#echo " Setup Sys Shell  Version $VER "

#
# Define Obj
#	
OBJ_SYS_LOCATION=0x0103						# set
OBJ_SYS_IDU_PN=0x0107						# set
OBJ_SYS_IDU_SN=0x0108						# set
OBJ_SYS_RTC=0x010B						# set
OBJ_SYS_IP=0x010F						# set	
OBJ_SYS_MAC=0x010E						# set		
OBJ_SYS_MASK=0x0110						# set
OBJ_SYS_GATE=0x0111						# set
OBJ_SYS_TRAPHOST1=0x0112					# set
OBJ_SYS_TRAPHOST2=0x0113					# set
OBJ_SYS_TRAPHOST3=0x0114					# set
OBJ_SYS_RESTARTCPU=0x0115					# set
OBJ_SYS_ROCOMMUNITY=0x0119					# set
OBJ_SYS_RWCOMMUNITY=0x011A					# set
OBJ_SYS_SNMP_MAIL=0x011B					# set
OBJ_SYS_SNMP_WEB=0x011C						# set
OBJ_SYS_SNMP_TRAPPORT=0x011D					# set

OBJ_SYS_WEB_USERNAME=0x011E					# set
OBJ_SYS_WEB_PASSWORD=0x011F					# set
OBJ_SYS_SET_MAC_MAN=0x0121					# set
OBJ_SYS_UPDATE_MAC_MAN=0x0122					# set without args.
OBJ_SYS_CLI_WELCOME_MSG=0x0123					# set
OBJ_SYS_CLI_USER=0x0124						# set
OBJ_SYS_CLI_PASSWORD=0x0125					# set
OBJ_SYS_PRODUCT_NAME=0x0126					# set
OBJ_SYS_PRODUCT_DESCRIPTION=0x0127				# set
OBJ_SYS_UPDATE_PRODUCT=0x0128					# set without args.

OBJ_LIC_ADDR=0x0C03 						# set
OBJ_LIC_GEN_SSN=0x0C04 						# set without args
OBJ_LIC_UPDATE_LICENSE=0x0C0D 					# set
OBJ_LIC_DEL=0x0C11						# set

chPara(){
#	echo $@;
#	echo $1
#	echo $2
#	change by camel 20100910 for eom
	if [ $1 = "PRODUCT_NAME_SYS" || $1 = "PRODUCT_DESCRIPTION_SYS"] ; then
		local findresult="`grep "$1=" /home/config/oem.conf | cut -f2 -d"="`";
		local old=${findresult};
		sed -i -e "s|$1=$old|$1=$2|g" /home/config/oem.conf
	fi
		local findresult="`grep "$1=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`";
#		echo "${findresult}";
		local old=${findresult};
#		echo $old;
#		sed -i -e "s|$1=$old|$1=$2|g" /home/PDH/PDH_IDU.conf
		sed -i -e "s|$1=$old|$1=$2|g" /home/config/PDH_IDU.conf
}

chInterface(){
#	echo $@
#	echo $1
#	echo $2
	local findresult="`grep "$1" /etc/network/interfaces | cut -f2 -d" "`";
#	echo "${findresult}";
	local old=${findresult};
#	echo $old;
	sed -i -e "s|$1 $old|$1 $2|g" /etc/network/interfaces
}

chMAC(){
#	echo $@;
#	echo $1
#	echo $2
	local findresult="`grep "$1=" /home/PDH/MAC.conf | cut -f2 -d"="`";
#	echo "${findresult}";
	local old=${findresult};
#	echo $old;
#	sed -i -e "s|$1=$old|$1=$2|g" /home/PDH/MAC.conf
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/MAC.conf
}

chCommunity(){
#	echo $@
#	echo $1
#	echo $2
	local findresult="`grep  "$1" /home/config/snmpd.conf | tail -n 1 | cut -f3 -d" "`";
#	echo "${findresult}";
	local old=${findresult};
#	echo $old;
	sed -i -e "s|$1  $old|$1  $2|g" /home/config/snmpd.conf
	local findresult="`grep  "$1" /home/config/oem.conf | cut -f2 -d"="`";
#	echo "${findresult}";
	local old=${findresult};
#	echo $old;
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/oem.conf
}

chSnmpMisc(){
	local findresult="`grep "$1=" /home/config/snmp_misc.conf | cut -f2 -d"="`";
	local old=${findresult};
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/snmp_misc.conf
	findresult="`grep "$1=" /home/config/oem.conf | cut -f2 -d"="`";
	old=${findresult};
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/oem.conf
}

chWebPassword(){
	local findresult="`grep "$1:" /home/config/password.conf | cut -f2 -d":"`";
	local old=${findresult};
	sed -i -e "s|$1:$old|$1:$2|g" /home/config/password.conf
}

chMacMan(){
	local findresult="`grep "$1=" /home/config/mac_man.conf | cut -f2 -d"="`";
	local old=${findresult};
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/mac_man.conf
	findresult="`grep "$1=" /home/config/oem.conf | cut -f2 -d"="`";
	old=${findresult};
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/oem.conf
}

chCLIUser(){
	local findresult="`grep "$1" /home/config/cli.conf | cut -f2 -d":"`";
	local old=${findresult};
	pass=`grep "$1" /home/config/cli.conf | cut -f3 -d":"`
	sed -i -e "s|$1:$old:$pass|$1:$2:$pass|g" /home/config/cli.conf
}

chCLIPassword(){
	local findresult="`grep "$1" /home/config/cli.conf | cut -f3 -d":"`";
	local old=${findresult};
	user=`grep "$1" /home/config/cli.conf | cut -f2 -d":"`
	sed -i -e "s|$1:$user:$old|$1:$user:$2|g" /home/config/cli.conf
}

chCLIWelcomeMsg(){
	local findresult="`grep "$1" /home/config/cli.conf | cut -f2 -d":"`";
	local old=${findresult};
	sed -i -e "s|$1:$old|$1:$2|g" /home/config/cli.conf
}

chLicSSN(){
	local findresult="`grep "$1" /home/config/short.ssn | cut -f2 -d"="`";
	local old=${findresult};
	sed -i -e "s|$1=$old|$1=$2|g" /home/config/short.ssn
}

#
#	log
#
/home/PDH/log.sh Log_Type_Set_SYS $1 $2


#
# Location
#
if [ $1 = $OBJ_SYS_LOCATION ]; then
	chPara LOCATION_SYS $2
	/home/PDH/setup_idu.sh 0x0A0C $2
fi

#
# PN
#
if [ $1 = $OBJ_SYS_IDU_PN ]; then
	chPara IDU_PN_SYS $2
fi

#
# SN
#
if [ $1 = $OBJ_SYS_IDU_SN ]; then
	chPara IDU_SN_SYS $2
fi

#
# RTC
#
if [ $1 = $OBJ_SYS_RTC ]; then
	date -s $2
	hwclock -w
fi

#
# IP
#
if [ $1 = $OBJ_SYS_IP ]; then
	ifconfig eth0 $2
	chInterface address $2
	/home/PDH/setup_idu.sh 0x0A01 $2
fi

#
# MAC
#
if [ $1 = $OBJ_SYS_MAC ]; then
	ifdown -a
	ifconfig eth0 hw ether $2
	ifup -a
	chMAC IDU_HWADDR $2
fi

#
# Mask
#
if [ $1 = $OBJ_SYS_MASK ]; then
	ifconfig eth0 netmask $2
	chInterface netmask $2
fi

#
# Gate
#
if [ $1 = $OBJ_SYS_GATE ]; then
	chInterface gateway $2
fi

#
# Traphost1
#
if [ $1 = $OBJ_SYS_TRAPHOST1 ]; then
	chPara TRAPHOST1_SYS $2	
fi

#
# Traphost2
#
if [ $1 = $OBJ_SYS_TRAPHOST2 ]; then
	chPara TRAPHOST2_SYS $2	
fi

#
# Traphost3
#
if [ $1 = $OBJ_SYS_TRAPHOST3 ]; then
	chPara TRAPHOST3_SYS $2	
fi

#
# Restart CPU
#
if [ $1 = $OBJ_SYS_RESTARTCPU ]; then
	if [ $2 = '1' ]; then
		/home/PDH/reboot.sh
	fi
fi

#
# Setup SNMP rocommunity
#
if [ $1 = $OBJ_SYS_ROCOMMUNITY ]; then
	chCommunity rocommunity $2	
fi

#
# Setup SNMP rwcommunity
#
if [ $1 = $OBJ_SYS_RWCOMMUNITY ]; then
	chCommunity rwcommunity $2	
fi

# Setup SNMP Eamil
if [ $1 = $OBJ_SYS_SNMP_MAIL ]; then
	chSnmpMisc snmp_email $2	
fi

# Setup SNMP Web
if [ $1 = $OBJ_SYS_SNMP_WEB ]; then
	chSnmpMisc snmp_web $2	
fi

# Setup SNMP Trapport
if [ $1 = $OBJ_SYS_SNMP_TRAPPORT ]; then
	chSnmpMisc snmp_trapport $2	
fi

# Setup Web Username
if [ $1 = $OBJ_SYS_WEB_USERNAME ]; then
	chWebPassword user $2	
fi

# Setup Web Password
if [ $1 = $OBJ_SYS_WEB_PASSWORD ]; then
	#------------------ md5 version ---------------------
	#p=`/home/SDH/bin/password $2 | grep -s "Digest"`
	#pp=`echo $p | cut -f1 -d":"`
	#ppp=`echo $p | cut -f2 -d":"`
	#if [ $pp = "Digest" ]; then
	#	chWebPassword password $ppp
	#fi	
	# ---------------------------------------------------
	# ----------------- clear-text ver ------------------
	chWebPassword password $2
	# ---------------------------------------------------
fi

# Setup Mac_Man ( to mac_man.conf )
if [ $1 = $OBJ_SYS_SET_MAC_MAN ]; then
	chMacMan cfg_man $2	
fi

# Update Mac_Man ( to MAC.conf )
if [ $1 = $OBJ_SYS_UPDATE_MAC_MAN ]; then
	man=`grep -s "cfg_man=" /home/config/mac_man.conf | cut -f2 -d"="`
#	echo $man
	old_mac=`grep -s "IDU_HWADDR=" /home/config/MAC.conf | cut -f2 -d"="`
#	echo $old_mac
	new_mac_low=`echo $old_mac | tail -c 7`
#	echo $new_mac_low
	new_mac=`echo -n $man$new_mac_low`
#	echo $new_mac
	chMAC IDU_HWADDR $new_mac
fi

# Setup CLI User
if [ $1 = $OBJ_SYS_CLI_USER ]; then
	chCLIUser USER1	$2
fi

# Setup CLI Password
if [ $1 = $OBJ_SYS_CLI_PASSWORD ]; then
	chCLIPassword USER1 $2
fi

# Setup CLI Welcome Message
if [ $1 = $OBJ_SYS_CLI_WELCOME_MSG ]; then
	chCLIWelcomeMsg WELCOME_MSG $2
fi

# Setup License :  short.ssn Address
if [ $1 = $OBJ_LIC_ADDR ]; then
	if [ -f /home/config/short.ssn ]; then
		chLicSSN SSNADDR $2
	else
		break
	fi
fi

# Setup License : generate short.ssn
if [ $1 = $OBJ_LIC_GEN_SSN ]; then
	/home/PDH/gen-ssn.sh
fi

# Setup License : update license
if [ $1 = $OBJ_LIC_UPDATE_LICENSE ]; then
	# restric num of args
	if [ $# = 2 ]; then
		break
	else
		echo  "5"
		exit	
	fi

	# if upload file exist
	if [ -f /home/config/$2 ]; then
		break
	else
		echo  "3"
		exit
	fi

	# if file match IDU
	LIC_VER=`grep "LICVER=" /home/config/$2 | cut -f2 -d"="`
	case $LIC_VER in
		001)
			# match
			LIC_ARM_ID=`grep "ARM_ID=" /home/config/$2 | cut -f2 -d"="`
			SERNUM_ARM_ID=`grep "ARM_SN=" /home/config/SerNum.conf | cut -f2 -d"="` # assume SerNum.conf exist
			if [ $LIC_ARM_ID = $SERNUM_ARM_ID ]; then
				break
			else
				echo  "2"
				exit
			fi
			# rename
			mv /home/config/$2 /home/config/license.dat
			# sign
			FEATURE_BASIC=`grep "FEATURE_BASIC=" /home/config/license.dat | cut -f2 -d"="`
			# write to FPGA
			/home/PDH/import_license -f $FEATURE_BASIC > /dev/null
			echo  "0"
			;;
		*)
			echo  "4"
			;;
	esac
fi

# Delete license file at /home/config/
if [ $1 = $OBJ_LIC_DEL ]; then
	# restrict num of args
	if [ $# = 2 ]; then
		break
	else
		echo -n "1"
		exit
	fi
	# file exist ? 
	if [ -f /home/config/$2 ]; then
		break
	else
		echo -n "2"
		exit
	fi
	# delete file
	rm -f /home/config/$2
	echo -n "0"
	exit
fi


