#!/bin/sh

# --------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#	2008-01-10		v0.0.1
#	2008-03-17		v0.0.2
#						with Para_1 : PDH_name
#	2008-05-13		v0.0.3
#						modify update software method
#	2008-05-22		v0.0.4
#						modify update software method
#						usage :
#							./up_software.sh $1		$1 : P1 or P2
#						return :
#							ERROR_UP_0	:	update success.
#							ERROR_UP_1	:	PDH_PKG_MD5 no found
#							ERROR_UP_2	:	PDH.tar.gz check error
#							ERROR_UP_3	:	PDH_MD5 no found
#							ERROR_UP_4	:	PDH(all files in ./PDH) check error : files no found or md5sum failed
#							ERROR_UP_5	:	PDH.tar.gz no found
#-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------


#
# Display what is the Shell
#
VER=0.0.4
#echo ""
#echo " Update SoftWare "
#echo " Version $VER "
#echo ""

# -------------------- v0.0.2 ----------------------
# list=`ls /home | grep -s $1`
# echo $list
# 
# if [ $list = $1 ]; then
# 	cd /home
# 	tar xzf $1
# 	rm -f $1
# 	echo "0"
# else
# 	echo "1"
# fi
# ----------------------------------------------------

path=/home/$1/

pdh_pkg_file=PDH.tar.gz
pdh_nms_chk_file=PDH_MD5
pdh_pkg_chk_file=PDH_PKG_MD5

# Entry $path
cd $path
pwd

# find PDH.tar.gz
file_name=`ls $pdh_pkg_file`
if [ $file_name = $pdh_pkg_file ]; then
	# find PDH_PKG_MD5
	file_name=`ls $pdh_pkg_chk_file`
	if [ $file_name = $pdh_pkg_chk_file ]; then
		# md5sum PDH.tar.gz with PDH_PKG_MD5
		md5_ok=`md5sum -c $pdh_pkg_chk_file | grep -s "OK" | cut -f2 -d":"`
		if [ $md5_ok = "OK" ]; then
			# tar PDH.tar.gz
			tar xzf $pdh_pkg_file
			# find PDH_MD5
			file_name=`ls $pdh_nms_chk_file`
			if [ $file_name = $pdh_nms_chk_file ]; then
				# line_num of PDH_MD5
				line_num_1=`cat $pdh_nms_chk_file | wc -l`
				#	echo -n "Line Num of " $pdh_nms_chk_file $line_num_1
				#	echo ""
				# md5sum all file in ./PDH with PDH_MD5 
				md5sum -c $pdh_nms_chk_file > /tmp/NULL
				# line_num of /tmp/NULL
				line_num_2=`grep -s "OK" /tmp/NULL | wc -l`
				#	echo -n "Line Num of /tmp/NULL " $line_num_2
				#	echo ""
				if [ $line_num_1 = $line_num_2 ]; then
					# remove $path/PDH.tar.gz
					rm -f $path$pdh_pkg_file
					# remove $path/PDH_PKG_MD5
					rm -f $path$pdh_pkg_chk_file
					# remove /tmp/NULL
					rm -f /tmp/NULL
					echo "ERROR_UP_0" # update Success
				else
					# remove /tmp/NULL
					rm -f /tmp/NULL
					echo "ERROR_UP_4" # PDH md5sum failrd with PDH_MD5
				fi
			else
				echo "ERROR_UP_3" # PDH_MD5 No Found
			fi
		else
			echo "ERROR_UP_2" # PDH.tar.gz md5sum failed with PDH_PKG_MD5
		fi
	else
		echo "ERROR_UP_1" # PDH_PKG_MD5 No Found
	fi
else
	echo "ERROR_UP_5" # PDH.tar.gz No Found
fi
